if not DrGBase then return end -- return if DrGBase isn't installed
ENT.Base = "drgbase_nextbot" -- DO NOT TOUCH (obviously)

-- Misc --
ENT.PrintName = "The Lamb"
ENT.Category = "Trevor Henderson"
ENT.Models = {"models/trevor_henderson/the_lamb/the_lamb.mdl"}
ENT.BloodColor = BLOOD_COLOR_RED
ENT.CollisionBounds = Vector(10, 10, 80)

-- Sounds --
ENT.OnIdleSounds = {
	"trevor_henderson/the_lamb/idle1.wav",
	"trevor_henderson/the_lamb/idle2.wav",
	"trevor_henderson/the_lamb/idle3.wav",
	"trevor_henderson/the_lamb/idle4.wav",
	"trevor_henderson/the_lamb/idle5.wav"
}
ENT.OnDamageSounds = {"trevor_henderson/the_lamb/damage.wav"}

-- Stats --
ENT.SpawnHealth = 3500

-- AI --
ENT.RangeAttackRange = 0
ENT.MeleeAttackRange = 70
ENT.ReachEnemyRange = 70
ENT.AvoidEnemyRange = 0

-- Relationships --
ENT.Factions = {"FACTION_LAMB"}
ENT.Frightening = true

-- Animations --
ENT.WalkAnimation = "0200"
ENT.RunAnimation = "0500"
ENT.IdleAnimation = "0000"

-- Movements --
ENT.WalkSpeed = 200
ENT.RunSpeed = 400

-- Detection --
ENT.EyeBone = "head"
ENT.EyeOffset = Vector(30, 0, 0)

-- Possession --
ENT.PossessionEnabled = true
ENT.PossessionMovement = POSSESSION_MOVE_8DIR
ENT.PossessionViews = {
	{
		offset = Vector(0, 75, 75),
		distance = 150
	},
	{
		offset = Vector(7.5, 0, 0),
		distance = 0,
		eyepos = true
	}
}
ENT.PossessionBinds = {
	[IN_ATTACK] = {{
		coroutine = true,
		onkeydown = function(self)
			self:PossessorNormal()
			self:FaceTowards(self:GetPos() + self:PossessorNormal())
			local ent = self:GetClosestEnemy()
			self:Grab(ent)
		end
	}},
	[IN_JUMP] = {{
		coroutine = true,
		onkeydown = function(self)
			self:Jump(500)
		end
	}},
	[IN_USE] = {{
		coroutine = true,
		onkeypressed = function(self)
			for k,ball in pairs(ents.FindInSphere(self:LocalToWorld(Vector(0,0,75)), 50)) do
				if IsValid(ball) and ball:GetClass() == "prop_door_rotating" then
					self:DoorCode(ball)
				end
			end
		end
	}}
}

if SERVER then

  -- Helpers --

function ENT:snd(a)
	self:EmitSound(a)
	self:EmitSound("re2/em6200/foley_long"..math.random(2)..".mp3")
end
function ENT:AttackFunction()
	self:Attack({
		damage = 10,
		viewpunch = Angle(40, 0, 0),
		type = DMG_CRUSH,range=100,angle=135,
	}, function(self, hit)
		if #hit == 0 then self:snd("re2/em6200/attack_swing"..math.random(5)..".mp3")return end 
		self:snd("re2/em6200/attack_hit"..math.random(5)..".mp3")
	end)
end

  -- Init/Think --

function ENT:CustomInitialize()
	self:SetDefaultRelationship(D_HT)
	self.BadBoy = true

	--// sequence events for ez sound playback
	local function stepsnd() self:snd("re2/em6200/step"..math.random(6)..".mp3") end
	
	self:SequenceEvent("3000",15/87,self.AttackFunction)
	self:SequenceEvent("3000",11/85,self.AttackFunction)
	
	self:SequenceEvent("3000",10/106,function()self:snd("re2/em6200/attack_swing"..math.random(5)..".mp3")end)
	self:SequenceEvent("3000",27/106,self.AttackFunction)
	self:SequenceEvent("3000",10/109,function()self:snd("re2/em6200/attack_swing"..math.random(5)..".mp3")end)
	self:SequenceEvent("3000",27/109,self.AttackFunction)
	
	self:SequenceEvent("ragdoll_grabA",{0, 0.23214285714286},function()self:snd("re2/em6200/attack_swing"..math.random(5)..".mp3")end)
	self:SequenceEvent("ragdoll_grabA",{0.23214285714286,0.41071428571429,0.96428571428571},stepsnd)
	self:SequenceEvent("ragdoll_grabB",{0.039473684210526,0.078947368421053,0.19736842105263},stepsnd)
	self:SequenceEvent("ragdoll_grabC",{0.053333333333333, 0.086666666666667, 0.12666666666667},stepsnd)
	
	self:SequenceEvent("taunt2",12/54,function()self:snd("re2/em6200/foley_taunt"..math.random(2)..".mp3")end)
	
	self:SequenceEvent({"taunt1", "taunt3"}, {math.Rand(0,.25),math.Rand(.25,.5),math.Rand(.5,.75),math.Rand(.75,1)}, function()
		self:snd("re2/em6200/foley_adjust_hat"..math.random(2)..".mp3")
	end)

	--// sequence events for ez sound playback
	
	self:SetName("The Lamb_"..self:EntIndex())
end
function ENT:HandleAnimEvent(a,b,c,d,e)
	if e == "step" then
		self:snd("re2/em6200/step"..math.random(6)..".mp3")
	end
	if e == "land" then
		self:snd("re2/em6200/land.mp3")
	end
	if e == "ladderclimb" then
		self:snd("re2/em6200/climb"..math.random(2)..".mp3")
	end
end

function ENT:DoorCode(door)
	if self:GetCooldown("MRXDoor") == 0 then
		self:SetCooldown("MRXDoor", 6)
		local doorseq,doordur = self:LookupSequence("9200")
		local doorseq2,doordur2 = self:LookupSequence("9201")
		if IsValid(door) and door:GetClass() == "prop_door_rotating" then
			self.CanOpenDoor = false
			self.CanAttack = false
			self:SetNotSolid(true)
			door:SetNotSolid(true)
			-- find ourselves to know which side of the door we're on
			local fwd = door:GetPos()+door:GetForward()*5
			local bck = door:GetPos()-door:GetForward()*5
			local pos = self:GetPos()
			local fuck_double_doors1 = door:GetKeyValues()
			local fuck_double_doors2 = nil
			if isstring(fuck_double_doors1.slavename) and fuck_double_doors1.slavename != "" then
				fuck_double_doors2 = ents.FindByName(fuck_double_doors1.slavename)[1]
			end

			if fwd:DistToSqr(pos) < bck:DistToSqr(pos) then -- entered from forward
				self:SetNotSolid(true)
				door:SetNotSolid(true)
				if isentity(fuck_double_doors2) then
					self:SetPos(door:GetPos()+(door:GetForward()*50)+(door:GetRight()*-50)+(door:GetUp()*-52))
				else
					self:SetPos(door:GetPos()+(door:GetForward()*80)+(door:GetRight()*-32)+(door:GetUp()*-52))
				end
				local ang = door:GetAngles()
				ang:RotateAroundAxis(Vector(0,0,1),180)
				self:SetAngles(ang)
			elseif bck:DistToSqr(pos) < fwd:DistToSqr(pos) then -- entered from backward
				self:SetNotSolid(true)
				door:SetNotSolid(true)
				if isentity(fuck_double_doors2) then
					self:SetPos(door:GetPos()+(door:GetForward()*-50)+(door:GetRight()*-50)+(door:GetUp()*-52))
				else
					self:SetPos(door:GetPos()+(door:GetForward()*-80)+(door:GetRight()*-12)+(door:GetUp()*-52))
				end
				local a = (door:GetAngles())
				a:Normalize()
				self:SetAngles(a)
			end
			-- find ourselves to know which side of the door we're on
			if (fwd:DistToSqr(pos) < bck:DistToSqr(pos)) or (bck:DistToSqr(pos) < fwd:DistToSqr(pos)) then

				self:SetNotSolid(true)
				door:SetNotSolid(true)
				door:Fire("setspeed",500)

				if isentity(fuck_double_doors2) then
					fuck_double_doors2:SetNotSolid(true)
					fuck_double_doors2:Fire("setspeed",500)

					self:Timer(7/30,function()
						self:EmitSound("doors/vent_open3.wav",511,math.random(50,80))
						door:Fire("openawayfrom",self:GetName())
						fuck_double_doors2:Fire("openawayfrom",self:GetName())
					end)
					self:Timer(doordur2,function()
						door:Fire("setspeed",100)
						door:Fire("close")
						fuck_double_doors2:Fire("setspeed",100)
						fuck_double_doors2:Fire("close")
						self:Timer(1,function()
							door:SetNotSolid(false)
							fuck_double_doors2:SetNotSolid(false)
							self.CanOpenDoor = true
							self.CanAttack = true
							self.CanFlinch = false
							self:SetNotSolid(false)
						end)
					end)
					self:PlaySequence("9201",{rate=1, gravity=true, collisions=false})
				else
					self:Timer(0.5,function()
						if !IsValid(self) then return end
						self:EmitSound("doors/vent_open3.wav",511,math.random(50,80))
						door:Fire("openawayfrom",self:GetName())
					end)
					self:Timer(doordur,function()
						if !IsValid(self) then return end
						door:Fire("setspeed",100)
						door:Fire("close")
						self:Timer(0.2,function()
							door:SetNotSolid(false)
							if !IsValid(self) then return end
							self.CanOpenDoor = true
							self.CanAttack = true
							self.CanFlinch = false
							self:SetNotSolid(false)
						end)
					end)
					self:PlaySequence("9200",{rate=1, gravity=true, collisions=false})
				end
			else
				self:Timer(1,function()
					door:SetNotSolid(false)
					self:Timer(1,function()
						if !IsValid(self) then return end
						self.CanOpenDoor = true
					end)
					if !IsValid(self) then return end
					self.CanAttack = true
					self.CanFlinch = false
					self:SetNotSolid(false)
				end)
			end
		end
	end
end

function ENT:CustomThink()
	for k,ball in pairs(ents.FindInSphere(self:LocalToWorld(Vector(0,0,75)), 50)) do
		if IsValid(ball) and ball:GetClass() == "prop_door_rotating" then
			if ball:GetClass() == "prop_door_rotating" then self:DoorCode(ball) end
			if ball:GetClass() == "func_door_rotating" then ball:Fire("open") end
			if ball:GetClass() == "func_door" then ball:Fire("open") end
		end
	end
end

function ENT:OnNewEnemy(enemy)
	self:EmitSound("trevor_henderson/the_lamb/newenemy.wav")
end

function ENT:Grab(ent)
	local grabbed = true
	local succeed = true
	if not IsValid(ent) then return end
	if self:GetHullRangeSquaredTo(ent) > 50^2 then return end
		
	local dmg = DamageInfo() dmg:SetAttacker(self)
	local ragdoll = ent:DrG_RagdollDeath(dmg)
	
	actualragdoll = self:GrabRagdoll(ragdoll, "head", "tag_ragdoll_attach")
	self:snd("re2/em6200/climb"..math.random(2)..".mp3")
	if ent:IsPlayer() then ent:SetPos(self:GetPos() + (self:GetForward()*60) + Vector(0,0,60)) end
	self:EmitSound("physics/body/body_medium_break"..math.random(2,3)..".wav",511,100)
	ParticleEffectAttach("blood_advisor_puncture",PATTACH_POINT_FOLLOW,self,3)
	for i=1,math.random(5,10) do ParticleEffectAttach("blood_impact_red_01",PATTACH_POINT_FOLLOW,self,3) end
	if (ent:IsPlayer() and !ent:Alive()) then
		ent:ScreenFade(SCREENFADE.IN,Color(255,0,0,255),0.3,0.2)
		self:snd("player/pl_pain"..math.random(5,7)..".wav",511,100)
	end
	SafeRemoveEntity(actualragdoll)
end

function ENT:OnMeleeAttack(enemy)
	if enemy:Health() < (enemy:GetMaxHealth()*0.25) then
		if enemy.VJ_IsHugeMonster then
			self:AttackFunction()
		else
			self:Grab(enemy)
			self:SetModelScale(self:GetModelScale() +0.01,0)
		end
	else
		if enemy:GetClass() == "npc_citizen" or enemy:GetClass() == "npc_combine_s" or enemy:GetClass() == "player" then
			self:Grab(enemy)
			self:SetModelScale(self:GetModelScale() +0.01,0)
		else
			self:AttackFunction()
		end
	end
	if enemy.VJ_IsHugeMonster then
		local velocity = Vector(0, 150, 50)
		local right = self:GetPos()+self:GetRight()*1
		local left = self:GetPos()-self:GetRight()*1
		local pos = enemy:GetPos()
		local dmg = DamageInfo()
		dmg:SetDamage(100)
		dmg:SetDamageForce(self:GetRight()* -velocity)
		dmg:SetDamageType(DMG_CLUB)
		dmg:SetAttacker(self)
		dmg:SetReportedPosition(self:GetPos())

		enemy:SetVelocity(self:GetRight()* -velocity)
		enemy:TakeDamageInfo(dmg)
	end
end

  -- AI --

function ENT:OnReachedPatrol()
	self:Wait(math.random(3, 7))
end
function ENT:OnIdle()
	self:AddPatrolPos(self:RandomPos(1500))
end
end

-- DO NOT TOUCH --
AddCSLuaFile()
DrGBase.AddNextbot(ENT)
